
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

public final class Encoder implements CuteCParserVisitor {
    // Jin-Suk,  ͸ ߴ ˱ ؼ   
    private int rs = Machine.R1;   
    private int nextInstrAddr;
    private ErrorReporter reporter;
    private Value value = new Value();
    
    private RuntimeEntity table[] = new RuntimeEntity[100];    
    private int tableSize = 0;
    
    private String fTable[] = new String[10];
    private int fTableSize = 0;
    
    
    public ErrorReporter getReport()
    {
        return reporter;
    }
    
    public Encoder () {
    //    this.reporter = reporter;
        reporter = new ErrorReporter();
        nextInstrAddr = Machine.CB;
        elaborateStdEnvironment();
    }
    
    public void  encodeRun(Node node)
    {
        node.jjtAccept(this,new Frame(0,0));
        //emit(Machine.HALTop, 0, 0, 0);
    }

    private void emit (int op, int r,int rs,int rs2,int opo,int n, Value d) {
        //ӽ÷ 
        System.out.println("op "+"r "+"rs "+"rs2 "+"opo "+"n "+"d ");
        System.out.println(op +" "+r+" "+rs+" "+rs2+" "+opo+" "+n+" "+d);
        Instruction nextInstr = new Instruction();
        
        if (n > 255) {
            reporter.reportError("length of operand can't exceed 255 words",null,null);
            n = 255; // to allow code generation to continue
        }        
        nextInstr.op = op;
        nextInstr.r = r;
        nextInstr.rs = rs;
        nextInstr.rs2 = rs2;
        nextInstr.opo = opo;
        nextInstr.n = n;        
        
        nextInstr.d.assign(d);
        
        
        d.reset();
        if (nextInstrAddr == Machine.PB)
          reporter.reportError("too many instructions for code segment",null,null);
        else {
            Machine.code[nextInstrAddr] = nextInstr;
            nextInstrAddr = nextInstrAddr + 1;
        }
      }
  
    // Patches the d-field of the instruction at address addr.
    private void patch (int addr, Value d) {
      Machine.code[addr].d.assign(d);
    }


    public Object visit(ASTProgramDeclaration node, Object data)
    {
        Frame frame = (Frame) data;

        //  Լ   Ұ
        int n = node.children.length;
        for (int i=0; i<n; i++){
            ASTFunctionDeclaration a =(ASTFunctionDeclaration)node.children[i];
            ASTIdentifier id = (ASTIdentifier)a.children[1];
            
            fTable[i]=id.spelling;
            fTableSize ++;
            
        }
        node.children[fTableSize-1].jjtAccept(this,frame);    
        
        
        return null;
    }
    
    public Object visit(SimpleNode node, Object data)
    {
        return null;
    }
    
    public Object visit(ASTFunctionDeclaration node, Object data)    {
        Frame frame = (Frame) data;
        
        int jumpAddr = nextInstrAddr;
        int argsSize = 0, valSize = 0;
        
        
        //emit(Machine.JUMPop, 0, Machine.CBr, 0);
        value.go_int(0);
        emit(Machine.JUMPop,Machine.CBr,0,0,0,0,value);
        node.entity = new KnownRoutine(Machine.closureSize, frame.level, nextInstrAddr);
        
        Frame frame1 = new Frame(frame.level + 1, 0);
        argsSize = ((Integer)node.children[2].jjtAccept(this,frame1)).intValue();
        Frame frame2 = new Frame(frame.level + 1, Machine.linkDataSize);
        valSize = ((Integer)node.children[3].jjtAccept(this,frame2)).intValue();
        
        value.go_int(argsSize);
        emit(Machine.RETURNop,0,0,0,valSize, 0, value);
        value.go_int(nextInstrAddr);
        patch(jumpAddr, value);
        return new Integer(0);
 /*   
        //ast.entity = new KnownRoutine(Machine.closureSize, frame.level, nextInstrAddr);

        //ASTFunctionDeclaration  ڽ
        //children[0]= return type
        //children[1]= identifier
        //children[2]= Ķ͵
        //children[3]= Ŀ 
        
        //Լ ǿ Ÿ ޾ƿ´. - 
        ASTType rType=(ASTType)node.children[0].jjtAccept(this,null);
        if(reporter == null)
        {
            System.out.println("asdfsdf");
            return null;
        }
        if ( reporter.numErrors > 0 ){
            return null;
        }        
        //̸  Űؼ id̺ 
        //idTable.enter (((ASTIdentifier)node.children[1]).spelling, node); // permits recursion
        //ߺȮ        
        if (node.duplicated)
          reporter.reportError ("identifier \"%\" already declared",
                  ((ASTIdentifier)node.children[1]).spelling, node.position);
        //id̺         
        
        //idTable.openScope();
        //Ķ  Ʈ ؼ 
        node.children[2].jjtAccept(this,null);
        
        //Ŀ忡  Լ ٵ ϴ Ÿ ޾ƿ´.
        ASTType aType = (ASTType)node.children[3].jjtAccept(this, null);
        if ( reporter.numErrors > 0 ){
            return null;
        }        
        
        //idTable.closeScope();
        //Լ Ÿ԰ Ŀ Ÿ ؼ  
                      
        if( aType == null || rType.type != aType.type)
            reporter.reportError ("body of function \"%\" has wrong type",
                    ((SimpleNode)node.children[1]).spelling, ((SimpleNode)node.children[3]).position);
            
       
       /* if ( type != ((ASTCompoundSt)node.children[3]).type ){
            reporter.reportError ("body of function \"%\" has wrong type",
                    ((SimpleNode)node.children[1]).spelling, ((SimpleNode)node.children[3]).position);
 
        }
        
        return frame;
        */

    }
    public Object visit(ASTCompoundSt node, Object data)
    {
     
        Frame frame = (Frame) data;
        int extrasize = ((Integer)node.children[0].jjtAccept(this,frame)).intValue();
        for(int i=1; i<node.children.length; i++)
        {
            extrasize = extrasize + ((Integer)node.children[i].jjtAccept
                    (this,new Frame(frame,extrasize))).intValue();
        }
        return new Integer(extrasize);
    }
    
    public Object visit(ASTBlockStatement node, Object data)
    {
        Frame frame = (Frame) data;
        
        return (Integer)node.children[0].jjtAccept(this,frame);
    }
    
    public Object visit(ASTStatement node, Object data)
    {
        Frame frame = (Frame) data;
        if (node.spelling == null)
            node.children[0].jjtAccept(this, frame);
        // return ̸ RETURNop ҷ ϴµ RETURNop  ȵ
        else if (node.spelling.equals("return"))
            node.children[0].jjtAccept(this, frame);
        // break continue  while jumpϴ ּҸ
        // ˾ƾ ϴµ 𸣹Ƿ while_st ּҸ  ϴ    
        else if (node.spelling.equals("break"))
            ;
        else if (node.spelling.equals("continue"))
            ;
        else
            ;
        return new Integer(2);
    }

    // Jin-Suk,
    // BackPatching ؼ , å 
    public Object visit(ASTConditionalSt node, Object data)
    {
        Frame frame = (Frame) data;
        int jumpifAddr, jumpAddr;

        node.children[0].jjtAccept(this, frame);
        jumpifAddr = nextInstrAddr;
        value.go_int(0);
        emit(Machine.JUMPIFop, Machine.CBr, Machine.Racc, 0, 0, Machine.falseRep, value);
        node.children[1].jjtAccept(this, frame);
        jumpAddr = nextInstrAddr;
        value.go_int(0);
        emit(Machine.JUMPop, Machine.CBr, 0, 0, 0, 0, value);
        value.go_int(nextInstrAddr);
        patch(jumpifAddr, value);
        if (node.children.length == 3)
            node.children[2].jjtAccept(this, frame);
        value.go_int(nextInstrAddr);
        
        patch(jumpAddr, value);
        return null;        
    }
    
    // Jin-Suk, 
    // BackPatching ؼ , å 
    public Object visit(ASTWhileSt node, Object data)
    {
        Frame frame = (Frame) data;
        int jumpAddr, loopAddr;

        jumpAddr = nextInstrAddr;
        value.go_int(0);
        emit(Machine.JUMPop, Machine.CBr, 0, 0, 0, 0, value);
        loopAddr = nextInstrAddr;
        node.children[1].jjtAccept(this, frame);
        value.go_int(nextInstrAddr);
        patch(jumpAddr, value);
        node.children[0].jjtAccept(this, frame);
        value.go_int(loopAddr);
        emit(Machine.JUMPIFop, Machine.CBr, Machine.Racc, 0, 0, Machine.trueRep, value);
        return null;
    }
    
    public Object visit(ASTExpression node, Object data)
    {
        // Jin-Suk,
        // child assignment̰ų expression
        Frame frame = (Frame) data;
        node.children[0].jjtAccept(this, frame);
        return null;       
    }
    
    public Object visit(ASTVariableDeclarator node, Object data)
    {
        // ڽ ϳ Ǵ ΰ üִ.
        // ϳ϶ ASTIdentifier ְ
        // ΰ϶ ASTArrayInitializer ƴϸ ASTExpression  ´
        // ڽ ϳ϶ ũⰡ 1 ϳ
        // 迭   ASTArrayInitializer    Ѵ
        // 
        Frame frame = (Frame) data;
        if(node.children.length != 1)
        {
            // 迭϶ 迭  
            if(node.children[1] instanceof ASTArrayInitializer)
                return node.children[1].jjtAccept(this,frame);
            // 迭 ƴ϶ ׳ 

            node.children[1].jjtAccept(this,frame);
            value.go_int(frame.size);
            emit(Machine.STOREop,frame.level,rs-1,0,0,0,value);
            
        }

        return new Integer(1);
    }
    public Object visit(ASTArrayInitializer node, Object data)
    {
        Frame frame = (Frame) data;
        int res = node.children.length;
        for(int i=0; i<node.children.length; i++)
        {
            node.children[i].jjtAccept(this,frame);
   //         emit(Machine.STOREop,frame.level,rs-1,0,0,0,1);
            
        }
        return new Integer(res);
    }
    public Object visit(ASTFormalParameters node, Object data)
    {
        Frame frame = (Frame) data;
        if(node.children == null)
            return new Integer(0);
        return (Integer)node.children[0].jjtAccept(this,frame);
        
    }
    public Object visit(ASTFormalParameter node, Object data)
    {

        Frame frame = (Frame) data;
        int extraSize;
        extraSize = ((Integer) node.children[0].jjtAccept(this,null)).intValue();
        value.go_int(extraSize);
        emit(Machine.LOADop,0,0,0 ,0, 0, value);
   
        node.entity = new KnownAddress(Machine.addressSize, frame.level, frame.size);    
        ASTName t = (ASTName)node.children[1];
  
        node.entity.id = ((ASTIdentifier)t.children[0]).spelling;
        System.out.println(node.entity.id);
        table[tableSize] = node.entity;
        tableSize++;
        
        System.out.println("  : " + frame.level + " ,    : " + frame.size);
        return new Integer(extraSize);
    }
    public Object visit(ASTType node, Object data)
    {
        Frame frame = (Frame) data;
        int size = 1;  //  Ÿ  1 
        
        return new Integer(size);
    }
    public Object visit(ASTPrimitiveTypeLookahead node, Object data)
    {
        Frame frame = (Frame) data;
        return null;
    }
    public Object visit(ASTPrimaryExpression node, Object data)
    {
        // Jin-Suk,
        // ϴ prefix湮, suffix  ߰ ʿ
        Frame frame = (Frame) data;
        node.children[0].jjtAccept(this, frame);
        return null;
    }
    public Object visit(ASTPrimaryPrefix node, Object data)
    {
        // Jin-Suk,
        // Literal, Expression̸ ׳ visit ϸ .
        // Name̸ encodeFetchԼ Name Ѱ 
        Frame frame = (Frame) data;
        if (node.children[0] instanceof ASTName)
            encodeFetch (node, frame);
        else 
            node.children[0].jjtAccept(this, frame);
        return null;
        
    }
    public Object visit(ASTCallCommand node, Object data)
    {
        Frame frame = (Frame) data;
    
        Integer argsSize = (Integer)node.children[1].jjtAccept(this,frame);
        ASTName a = (ASTName)node.children[0];
        ASTIdentifier id = (ASTIdentifier)a.children[0];
      
        
        if(id.spelling.equals("print"))
            System.out.println("print Ҵ");
        
        if(id.spelling.equals("println"))
            System.out.println("println Ҵ");
        /*
        int i=0;
        for(i=fTableSize-1; i>=0;i--)
        {
            if(fTable[i].equals( id.spelling))
            {
               System.out.println("Լ : "+ fTable[i]);
               break;
            }
        }
        
        
        System.out.println(i);
        SimpleNode n, m;
        m = node;
        n = (SimpleNode)m.parent;
        
        while(n!=null)
        {
            m=n;
            n=(SimpleNode)n.parent;
            
        }
            
        System.out.println(m.toString());
 //       m.children[i].jjtAccept(this,frame);
        
        //node.children[0].jjtAccept(this, new Frame(frame.level, argsSize));
    */
        
        return null;
    }
    public Object visit(ASTPrimarySuffix node, Object data)  
    {
        Frame frame = (Frame) data;
        return null;
    }
    
    public Object visit(ASTArgumentList node, Object data)
    {
        Frame frame = (Frame) data;
        int res = node.children.length;
        return new Integer(res);
    }
    
    // Jin-Suk,
    // Literal R[rs] loadϰ rs 1 Ŵ
    public Object visit(ASTLiteral node, Object data)
    {
        // R4  Ǹ   R1 ű   R2 
        if (rs > Machine.R4)    {
            value.go_int(0);
            emit (Machine.LOADRop, 0, Machine.R1, Machine.Racc, 0, 0, value);
            rs = Machine.R2;         
        }
        if (node.type == ASTType.T_INT) 
        {
            value.go_int(Integer.parseInt(node.spelling));
            emit(Machine.LOADLop, 0, rs++, 0, 0, 0, value);
        }
        else if (node.type == ASTType.T_CHAR)
        {
            value.go_int(node.spelling.charAt(1));
            emit(Machine.LOADLop, 0, rs++, 0, 0, 0,value );
        }
        // float, boolean  ӽſ  ʿ
        else if (node.type == ASTType.T_FLOAT)
        {
            value.go_float(Float.parseFloat(node.spelling));
            emit(Machine.LOADLop, 0, rs++, 0, 0, 0, value);
        }
        else
        {
            value.go_bool(Boolean.parseBoolean(node.spelling));
            emit(Machine.LOADLop, 0, rs++, 0, 0, 0,value );
        }
        return null;
    }
    
    public Object visit(ASTAssignment node, Object data)
    {
        Frame frame = (Frame) data;
        node.children[1].jjtAccept(this, frame);
        node.children[0].jjtAccept(this, frame);
        
        ASTPrimaryExpression t = (ASTPrimaryExpression)node.children[0];
        ASTName n = (ASTName)t.children[0];
        ASTIdentifier a  = (ASTIdentifier)n.children[0];
        String tmp = a.spelling;
        
        
        for(int i=tableSize-1; i>=0; i--)
        {
            ObjectAddress o = ((KnownAddress)table[i]).address;
            if(tmp.equals(table[i].id))
            {
                System.out.println("asdfsa   " + o.displacement);
                break;
            }
        }
        return null;
    }
    
    // Jin-Suk,
    //  operator ڽ  ̻   operator  Ǵ ̹Ƿ
    // CALLop emitϰ ϴ ʹ ٷ  ƴ    
    //  Ѵ. 
    public Object visit(ASTConditionalOrExpression node, Object data)
    {
        Frame frame = (Frame) data;
        node.children[0].jjtAccept(this, frame);
        if (node.children.length > 1)
            for(int i = 1; i < node.children.length; i++)    {
                node.children[i].jjtAccept(this, frame);
                value.go_int(0);
                emit (Machine.CALLop, 0, rs-1, rs-2, Machine.orDisplacement, 0, value);
            }
        return null;
    }
    
    public Object visit(ASTConditionalAndExpression node, Object data)
    {
        Frame frame = (Frame) data;
        node.children[0].jjtAccept(this, frame);
        if (node.children.length > 1)
            for(int i = 1; i < node.children.length; i++)    {
                node.children[i].jjtAccept(this, frame);
                value.go_int(0);
                emit (Machine.CALLop, 0, rs-1, rs-2, Machine.andDisplacement, 0, value);
            }
        return null;
    }
    
    public Object visit(ASTEqualityExpression node, Object data)
    {
        Frame frame = (Frame) data;
        node.children[0].jjtAccept(this, frame);
        if (node.children.length > 1)
            for(int i = 1; i < node.children.length; i++)    {
                node.children[i].jjtAccept(this, frame);
                value.go_int(0);
                emit (Machine.CALLop, 0, rs-1, rs-2, Machine.eqDisplacement, 0, value);
            }
        return null;
    }
    
    public Object visit(ASTRelationalExpression node, Object data)
    {
        Frame frame = (Frame) data;
        node.children[0].jjtAccept(this, frame);
        if (node.children.length > 1)
            for(int i = 1; i < node.children.length; i++)    {
                node.children[i].jjtAccept(this, frame);
                if (node.spelling.equals("<"))
                {
                    value.go_int(0);
                    emit (Machine.CALLop, 0, rs-1, rs-2, Machine.ltDisplacement, 0, value);
                }
                else
                {
                    value.go_int(0);
                    emit (Machine.CALLop, 0, rs-1, rs-2, Machine.gtDisplacement, 0, value);
                }
                
            }
        return null;
    }
    public Object visit(ASTAdditiveExpression node, Object data)
    {
        Frame frame = (Frame) data;
        node.children[0].jjtAccept(this, frame);
        if (node.children.length > 1)
            for(int i = 1; i < node.children.length; i++)    {
                node.children[i].jjtAccept(this, frame);
                if (node.spelling.equals("+"))
                {
                    value.go_int(0);
                    emit (Machine.CALLop, 0, rs-1, rs-2, Machine.addDisplacement, 0, value);
                }
                else
                {
                    value.go_int(0);
                    emit (Machine.CALLop, 0, rs-1, rs-2, Machine.subDisplacement, 0, value);
                }
            }
        return null;
    }
    public Object visit(ASTMultiplicativeExpression node, Object data)
    {
        Frame frame = (Frame) data;
        node.children[0].jjtAccept(this, frame);
        if (node.children.length > 1)
            for(int i = 1; i < node.children.length; i++)    {
                node.children[i].jjtAccept(this, frame);
                if (node.spelling.equals("*"))
                {
                    value.go_int(0);
                    emit (Machine.CALLop, 0, rs-1, rs-2, Machine.multDisplacement, 0, value);
                }
                else if (node.spelling.equals("/"))
                {
                    value.go_int(0);
                    emit (Machine.CALLop, 0, rs-1, rs-2, Machine.divDisplacement, 0, value);
                }
                else
                {   
                    value.go_int(0);
                    emit (Machine.CALLop, 0, rs, rs-1, Machine.modDisplacement, 0, value);
                }
            }
        return null;
    }
    
    public Object visit(ASTUnaryExpression node, Object data)
    {
        Frame frame = (Frame) data;
        node.children[0].jjtAccept(this, frame);
        if (node.spelling == null);
        else if (node.spelling.equals("!")) 
        {
            value.go_int(0);
            emit (Machine.CALLop, 0, rs-1, 0, Machine.notDisplacement, 0, value);
        }
        else
        {
            value.go_int(0);
            emit (Machine.CALLop, 0, rs-1, 0, Machine.negDisplacement, 0, value);
        }
        return null;
    }
    
    public Object visit(ASTLocalVariableDeclaration node, Object data)
    {

        Frame frame = (Frame) data;
        int extraSize;
        extraSize = ((Integer) node.children[1].jjtAccept(this,frame)).intValue(); // ش
        value.go_int(extraSize);
        emit(Machine.LOADop,0,0,0 ,0, 0, value);
        
        node.entity = new KnownAddress(Machine.addressSize, frame.level, frame.size);
        System.out.println("  : " + frame.level + " ,    : " + frame.size);
        
        ASTVariableDeclarator t = (ASTVariableDeclarator)node.children[1];
        node.entity.id = ((ASTIdentifier)t.children[0]).spelling;
        System.out.println(node.entity.id);
        table[tableSize] = node.entity;
        tableSize++;
        
 //       ObjectAddress a = ((KnownAddress)node.entity).address;
 //       System.out.println(node.entity);
 //       System.out.println("¥" + a.displacement);
//        node.level = frame.level;
 //       node.displacement = frame.size;
        return new Integer(extraSize);
     
        
    }
    public Object visit(ASTCastLookahead node, Object data)
    {
        Frame frame = (Frame) data;
        return null;
    }

    
    public Object visit(ASTName node, Object data)
    {
        //node.offset = 0;
        //node.indexed = false;
 //       System.out.println("sdfasdfa"+((ASTDeclaration)((ASTIdentifier)node.children[0]).decl).entity.toString());
          node.children[0].jjtAccept(this,data);
        return ((ASTDeclaration)((ASTIdentifier)node.children[0]).decl).entity;
    }
    public Object visit(ASTIdentifier node, Object data)
    {
        Frame frame = (Frame) data;
        return null;
    }
    public Object visit(ASTLHExpression node, Object data)
    {
        Frame frame = (Frame) data;
        encodeAssign (node, frame);
        
        return null;
    }

     
    // Decides run-time representation of a standard routine.
    private final void elaborateStdPrimRoutine (ASTDeclaration routineDeclaration,
                                            int routineOffset) {
      routineDeclaration.entity = new PrimitiveRoutine (Machine.closureSize, routineOffset);
    }
    
    private final void elaborateStdEqRoutine (ASTDeclaration routineDeclaration,
                                            int routineOffset) {
      routineDeclaration.entity = new EqualityRoutine (Machine.closureSize, routineOffset);
    }
    /*
    private final void elaborateStdRoutine (Declaration routineDeclaration,
                                            int routineOffset) {
      routineDeclaration.entity = new KnownRoutine (Machine.closureSize, 0, routineOffset);
    }
    */
    private final void elaborateStdEnvironment() {
     // elaborateStdConst(StdEnvironment.falseDecl, Machine.falseRep);
     // elaborateStdConst(StdEnvironment.trueDecl, Machine.trueRep);
      elaborateStdPrimRoutine(StdEnvironment.andDecl, Machine.andDisplacement);
      elaborateStdPrimRoutine(StdEnvironment.orDecl, Machine.orDisplacement);
      //elaborateStdConst(StdEnvironment.maxintDecl, Machine.maxintRep);
      elaborateStdPrimRoutine(StdEnvironment.addDecl, Machine.addDisplacement);
      elaborateStdPrimRoutine(StdEnvironment.subtractDecl, Machine.subDisplacement);
      elaborateStdPrimRoutine(StdEnvironment.multiplyDecl, Machine.multDisplacement);
      elaborateStdPrimRoutine(StdEnvironment.divideDecl, Machine.divDisplacement);
      elaborateStdPrimRoutine(StdEnvironment.moduloDecl, Machine.modDisplacement);
      elaborateStdPrimRoutine(StdEnvironment.lessDecl, Machine.ltDisplacement);
      elaborateStdPrimRoutine(StdEnvironment.greaterDecl, Machine.gtDisplacement);      
      elaborateStdPrimRoutine(StdEnvironment.negationDecl, Machine.negDisplacement);
      elaborateStdPrimRoutine(StdEnvironment.complementDecl, Machine.notDisplacement);
      elaborateStdEqRoutine(StdEnvironment.equalDecl, Machine.eqDisplacement);
    }
    
    // Returns the register number appropriate for object code at currentLevel
    // to address a data object at objectLevel.
    private int displayRegister (int currentLevel, int objectLevel) {
      if (objectLevel == 0)
        return Machine.SBr;
      else if (currentLevel - objectLevel <= 6)
        return Machine.LBr + currentLevel - objectLevel; // LBr|L1r|...|L6r
      else {
       // reporter.reportRestriction("can't access data more than 6 levels out");
        return Machine.L6r;  // to allow code generation to continue
      }
    }
    
    // Jin-Suk,
    // encodeFetch encodeAssign ۵ϴ   ÿ 
    // ġ Checker  ̹  decl ؼ entity  ޴´.  
    //  entity    ϴ   ִ    .
    // ϴ KnownAddress Ϲ  ؼ 
    // ASTName̳ ASTLHExpression  Լ    .
    // ׸ dispalyRegister  ص ʿ  .
    
    // encodeAssign AssignCommand º assignǴ   ̴. 
    // declaration   ߴ ġ ּҷ  .   
    private void encodeAssign(ASTLHExpression node, Frame frame) {
      RuntimeEntity baseObject = (RuntimeEntity) node.children[0].jjtAccept(this, frame);
      // If indexed = true, code will have been generated to load an index value.
      /*if (valSize > 255) {
        reporter.reportRestriction("can't store values larger than 255 words");
        valSize = 255; // to allow code generation to continue
      }*/
      if (baseObject instanceof KnownAddress) {
        ObjectAddress address = ((KnownAddress) baseObject).address;
        /*if (V.indexed) {
          emit(Machine.LOADAop, 0, displayRegister(frame.level, address.level),
               address.displacement + V.offset);
          emit(Machine.CALLop, Machine.SBr, Machine.PBr, Machine.addDisplacement);
          emit(Machine.STOREIop, valSize, 0, 0);
        } else {*/
        // ⵵ level displacement    .
        value.go_int(address.displacement);
        emit (Machine.STOREop, displayRegister(frame.level, address.level), rs-1,
                0, 0, 0, value);
        //emit(Machine.STOREop, valSize, displayRegister(frame.level,
         //address.level), address.displacement + V.offset);
      }
     /* } else if (baseObject instanceof UnknownAddress) {
        ObjectAddress address = ((UnknownAddress) baseObject).address;
        emit(Machine.LOADop, Machine.addressSize, displayRegister(frame.level,
             address.level), address.displacement);
        if (V.indexed)
          emit(Machine.CALLop, Machine.SBr, Machine.PBr, Machine.addDisplacement);
        if (V.offset != 0) {
          emit(Machine.LOADLop, 0, 0, V.offset);
          emit(Machine.CALLop, Machine.SBr, Machine.PBr, Machine.addDisplacement);
        }
        emit(Machine.STOREIop, valSize, 0, 0);
      }*/
    }
    
    // encodeFetch    ,  ּ  о´.
    private void encodeFetch(ASTPrimaryPrefix node, Frame frame) {

      RuntimeEntity baseObject = (RuntimeEntity) node.children[0].jjtAccept (this, frame);
      /*
      // If indexed = true, code will have been generated to load an index value.
      if (valSize > 255) {
        reporter.reportRestriction("can't load values larger than 255 words");
        valSize = 255; // to allow code generation to continue
      }*/
      
      if (baseObject instanceof KnownAddress) {
          ObjectAddress address = ((KnownAddress) baseObject).address;
      /*  if (V.indexed) {
          emit(Machine.LOADAop, 0, displayRegister(frame.level, address.level),
               address.displacement + V.offset);
          emit(Machine.CALLop, Machine.SBr, Machine.PBr, Machine.addDisplacement);
          emit(Machine.LOADIop, valSize, 0, 0);
        } else*/
          //  κ  dispalcement    .
          value.go_int(address.displacement);
          emit (Machine.LOADop, displayRegister(frame.level, address.level), rs++,
                  0, 0, 0, value);
         // emit(Machine.LOADop, valSize, displayRegister(frame.level,
         //         address.level), address.displacement + V.offset);
      } /*else if (baseObject instanceof UnknownAddress) {
        ObjectAddress address = ((UnknownAddress) baseObject).address;
        emit(Machine.LOADop, Machine.addressSize, displayRegister(frame.level,
             address.level), address.displacement);
        if (V.indexed)
          emit(Machine.CALLop, Machine.SBr, Machine.PBr, Machine.addDisplacement);
        if (V.offset != 0) {
          emit(Machine.LOADLop, 0, 0, V.offset);
          emit(Machine.CALLop, Machine.SBr, Machine.PBr, Machine.addDisplacement);
        }
        emit(Machine.LOADIop, valSize, 0, 0);
      }*/
    }

}


